function y_simu=MarkovChain(y_index,P,T,y_initial,n)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% This function simulates markov process with state y_index and transition
%% matrix P for periods T starting from an intial value y_initial. It returns a time series T
%%
%%     n:  index of seeds, if n<0, means no fix seeds     
%%
%% Author: Chang Ma,  Date: 06/20/2016
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%




y_simu=nan(T,1);
y_simu(1)=y_initial;

%% Construct CDF from transition matrx
F=P;
for i=2:length(y_index)
    F(:,i)=F(:,i)+F(:,i-1);
end
if n>0
    rand('seed',n);
end
r_v=rand(T,1);
for t=2:T
%     tran_ind=min(find(F(y_simu(t-1),:)>=r_v(t)));
    if isempty(find(r_v(t)>F(y_simu(t-1),:)))==1
        tran_ind=1;
    else
        tran_ind=min(length(y_index),max(find(r_v(t)>F(y_simu(t-1),:))+1));
    end
    y_simu(t)=tran_ind;
end